#!/bin/bash
# Nuova procedura di setup per Bpoin SP & C.

VERSIONE=2.7.6 ; VER_DATE="gio 18 gen 2018"
# - Corretto controllo sistema operativo anche per DS

#VERSIONE=2.7.5 ; VER_DATE="mer 25 ott 2017"
# - Aggiunto controllo sistema operativo
 
#VERSIONE=2.7.4 ; VER_DATE="mer 15 giu 2016"
# - Commentato read -p pause

#VERSIONE=2.7.3 ; VER_DATE="lun 30 mag 2016"
# - Mascarato output di wki.dsserver.exe

#VERSIONE=2.7.2 ; VER_DATE="lun 23 mag 2016"
# - Modificata gestione lettura pacchi con unzip per supportare cartelle con spazi

#VERSIONE=2.7.1 ; VER_DATE="mar 29 mar 2016"
# - Aggiunti messaggi di debug per la creazione struttura wkicosimi e file wkisuite

#VERSIONE=2.7.0 ; VER_DATE="lun 23 nov 2015"
# - Commentata l'esecuzione di makeconv per DS Smart

#VERSIONE=2.6.3 ; VER_DATE="mer 18 nov 2015"
# - Cambiata la chiamata di setup-bp-comp

#VERSIONE=2.6.2 ; VER_DATE="mar 17 nov 2015"
# - Se già esistenti non genero i file wkicosimi/wkisuite
# - Aggiunta esecuzione di makeconv per DS Smart

#VERSIONE=2.6.1 ; VER_DATE="gio 12 nov 2015"
# - Eliminato aggancio al setup di DS SMART
# - Aggiunta gestione pacchi zip aggiuntivi (pkg_extrazip_prima/pkg_extrazip_dopo)

#VERSIONE=2.6.0 ; VER_DATE="lun 2 nov 2015"
# - Inserito aggancio al setup di DS SMART
# - Spostamento e rinomina dei comandi setup-component.sh
#   e setup-dbpsql.sh in prg/cmd/unix con *-bp-*
# - Spostato creazone cartella wkicosimi/bpoint/db per owner postgres
# - Rimosso da chiamata setup-bp-component.sh variabile $setup_comp_opt

#VERSIONE=2.5.2 ; VER_DATE="mer 21 ott 2015"
# - Aggiunto caricamento e lancio mono per wki.dsserver.exe
#   da variabile external (DSSMART_BPSP_DIR) che indica la posizione di bpsp

#VERSIONE=2.5.1 ; VER_DATE="mar 20 ott 2015"
# - Modificato esecuzione pre/post install
# - Cambiata impostazione e caricamento aggio_mklogin
# - Aggiunta Eccezione per install sispacweb

#VERSIONE=2.5.0 ; VER_DATE="lun 05 ott 2015"
# - Aggiunta logica per aggiornamento BP DS dopo aggiornamento BP SP

#VERSIONE=2.4.7 ; VER_DATE="gio 30 apr 2015"
# - Corretto visualizzazione di bpointver contenente ^M finale

#VERSIONE=2.4.6 ; VER_DATE="lun 30 mar 2015"
# - Cambio nome per B.Point DS (modificato anche descrittore)

#VERSIONE=2.4.5 ; VER_DATE="lun 02 mar 2015"
# - Disabilitato creazione condivisione samba prg/com

#VERSIONE=2.4.4 ; VER_DATE="mar 27 gen 2015"
# - Disabilitato rimozione obsoleti per sub-package (xdbc)

#VERSIONE=2.4.3 ; VER_DATE="mar 04 nov 2014"
# - Modificato nome variabile (linux_supp_auto)
# - Modificato messaggio ricerca nome prodotto automatica
# - Rimosso errore di passaggio supporto con path relativo.

#VERSIONE=2.4.2 ; VER_DATE="gio 02 ott 2014"
# - Verifica esistena file i18n prima di effettuare la verifica. Se non esiste non controllo
# - cmd/setup-component.sh: Inserita eccezione per redhat/centos 7
# - cmd/setup-dbpsql.sh: Eccezione per Centos 7 (systemctl $tipo postgresql.service)
# - cmd/setup-dbpsql.sh: Eccezione per Centos 7 (postgresql-setup initdb)

#VERSIONE=2.4.1 ; VER_DATE="ven 29 ago 2014"
# - setup.sh: Collaudi e ritocchi

#VERSIONE=2.4.0 ; VER_DATE="ven 22 ago 2014"
# - setup.sh: Miglioramento e completamento procedure setup prima e dopo

#VERSIONE=2.3.2 ; VER_DATE="ven 01 ago 2014"
# - setup.sh: Attivazione procedure esterne prima e dopo il setup

#VERSIONE=2.3.1 ; VER_DATE="lun 28 lug 2014"
# - setup.sh: Aggiunta gestione dei sotto package

#VERSIONE=2.3.0 ; VER_DATE="gio 24 lug 2014"
# - setup.sh: Corretta gestione opzione -d
# - setup.sh: Gestione edz_tipo impostato ad 'automatico'

#VERSIONE=2.2.1 ; VER_DATE="ven 25 ott 2013"
# - setup.sh: Gestione nuovo cobol Visual Cobol
# - setup.sh: rimozione gestione cobol_{suse,redhat51}

#VERSIONE=2.2.0 ; VER_DATE="ven 11 gen 2013"
# - setup.sh: Aggiunta interazione con 'SH su richiesta licenza per aprire una shell

#VERSIONE=2.1.92 ; VER_DATE="mar 28 dic 2012"
# - setup.sh: Aggiunta interazione con 'SH su richiesta licenza per aprire una shell
# - cmd/setup-component.sh: Gestione postgres-lib

#VERSIONE=2.1.5 ; VER_DATE="ven 16 nov 2012"
# - cmd/setup-dbpsql.sh: Aggiunta consenso connessione md5 su localhost IPv6

#VERSIONE=2.1.4 ; VER_DATE="lun 29 ott 2012"
# - setup.sh: Modificato BPOINT_NAME da BPSTUDIO a BPOINT

#VERSIONE=2.1.3 ; VER_DATE="mar 17 apr 2012"
# - setup.sh: tolto controllo esistenza setup-repo-epel

#VERSIONE=2.1.2 ; VER_DATE="gio 16 feb 2012"
# - setup-component.sh: Aggiunta aggiornamento preventivo dei componenti da installare per x86_64
# - setup.sh: aggiunta opzione di STOP_DEBUG per test

#VERSIONE=2.1.1 ; VER_DATE="mar 14 feb 2012"
# - setup-component.sh: Aggiunta verifica componenti 32 per s.o. a 64 bit
# - setup.sh sostituito il test [ -n "$esegui_makeconv" ] con [ "$cod_prodotto" = bpds ]

#VERSIONE=2.1.0 ; VER_DATE="mer  8 feb 2012"
# - setup.sh: rimossa gestione installaione mono
# - setup-component.sh: rimossa gestione installaione mono

#VERSIONE=2.0.9 ; VER_DATE="mar 24 gen 2012"
# - setup.sh: aggiunta query RPM installati

#VERSIONE=2.0.8 ; VER_DATE="mar 24 gen 2012"
# - setup.sh: Catturato errore "cat ambver"
# - setup.sh: Spostato prelievo ora inizio elaborazione (data_start)

#VERSIONE=2.0.7 ; VER_DATE="ven 25 nov 2011"
# - setup.sh: aggiunto stop/start bpoin prima di eseguire backup
# - setup.sh: eliminato visualizzazione errori comendi info
# - setup.sh: Corretto errore opzioni --proxy 

#VERSIONE=2.0.6 ; VER_DATE="lun 14 nov 2011"
# - setup.sh: Aggiunto uso opzione --native-mode per check-libstd.sh
# - setup.sh: Aggiunto valore data procedura $VER_DATE

#VERSIONE=2.0.5 # mar 08 nov 2011
# - setup.sh: Registrato nei log il comando makeconv eseguito
# - setup.sh: Registrato nei log la versione di setup.sh e varie shell
# - setup.sh: Correzione verifica path rpm mono

#VERSIONE=2.0.4 # ven 04 nov 2011
# - setup.sh: aggiunto nel file di log informazioni sul tipo di sistema
# - setup.sh: PATH: do priorità a cmd residenti a dove si trova setup.sh
# - setup.sh: File di log: generato un file di log linkato con l'ultimo (wkisetup-last.log) 

#VERSIONE=2.0.2 # ven 28 ott 2011
# - cmd/setup-component.sh: inserita gestione EPEL per centos6

#VERSIONE=2.0.1 # mar 25 ott 2011
# - setup.sh: grep -E -q '.(UTF-8|utf8)$'
# - setup.sh: cambio nome variabile setup_comp_pg in opt_pg_std

#VERSIONE=2.0.0 # mar 11 ott 2011
# - setup.sh + cmd/setup-component.sh: inserita opzione test path rpm

#VERSIONE=1.9.95 # mar 04 ott 2011
# - setup.sh: ottimizzat uso cmd/setup-component.sh

#VERSIONE=1.9.94 # ven 09 set 2011
# - setup.sh: aggiunta opzione recupero RPMS per MONO

#VERSIONE=1.9.93 # mar 06 set 2011
# - setup.sh: controllo componenti mono-2.4
# - cmd/setup-component.sh: ...

#VERSIONE=1.9.92 # mar 30 ago 2011
# - cmd/setup-component.sh: Modificata frase visualizzata
# - cmd/setup-component.sh: Aggiunta opzione '--allmatches' in 'rpm -e'
# - setup.sh: spostata esecuzione backup database
# - setup.sh: aggiustato chkconfig per servizio samba
# - setup.sh: Inserito controllo $LANG
# - setup.sh: Inserito controllo esistenza wkicosimi

#VERSIONE=1.9.91 # mar 05 ago 2011
# - aggiunta opzione in setup.sh per forzatura postgres vecchio

#VERSIONE=1.9.90 # mar 26 lug 2011
# - Modificato settaggio PATH per uso comandi in cmd modificati
#   Per utilizzare i cmd modificati eseguire il setup.sh nel seguente modo:
#   PATH=/tmp/setup-loc/cmd/:$PATH sh setup.sh ....
# - Modificata la procedura ./cmd/setup-component in modo che install postgres84

#VERSIONE=1.9.7 # ven 29 apr 2011
# - Modificata procedura cmd/setup-chperm.sh per rimozione ridondanza parametri

#VERSIONE=1.9.6 # lun 28 feb 2011
# - Modificata lettura obsoleti in "rm-obsoleti.sh"

#VERSIONE=1.9.5 # ven 25 feb 2011
# - Cambiata gestione obsoleti

#VERSIONE=1.9.4 # mer 16 feb 2011
# - Aggiunto controllo per installazione BPDS controllo LANG

#VERSIONE=1.9.3 # mar 31 gen 2011
# - Migliorato messaggio contratto di licenza

#VERSIONE=1.9.2 # mar 18 gen 2011
# - Inserito controllo per "spds_verifica_licenza" 
# - Aggiunta visualizzazione file descrittore.ini nel file di log

#VERSIONE=1.9.1 # gio 23 dic 2010
# - Variata gestione riavvio dei servizi
# - Modificata descrizione opzione --prodotto
# - Aggiunto skip ('Q') ad uso interno per saltare EULA

#VERSIONE=1.9.0 # mar 21 dic 2010
# - Visualizzazione versione procedura setup al primo messaggio
# - Correzione baco installazione componenti in bpsp
# - Corretto baco creazione utente bpoin in installazione bpds
# - Modificato cmd/setup-chperm.sh per ch-accare anche .

#VERSIONE=1.8.2 # lun 20 dic 2010
# - Modificato output backup db postgres

#VERSIONE=1.8.1 # ven 17 dic 2010
# - Aggiunto debug alla procedura di settaggio permessi

#VERSIONE=1.8.0 # mar 14 dic 2010
# - Nuova verifica versione descrittore
# - Nuova gestione versione per bpSP/DS

#VERSIONE=1.7.3 # mar 07 dic 2010
# - Rimosso impostazione di debug kb_rel="0100"
# - Aggiunto BPOINT_NAME='BPSTUDIO' ( PROVVISORIO )

#VERSIONE=1.7.2 # ven 03 dic 2010
# - Aggiunta creazione link cobol_suse

#VERSIONE=1.7.1 # gio 02 dic 2010
# - Installazione servizi anche in aggiornamento
# - Inserimento opzione --proxy

#VERSIONE=1.7.0 # mer 01 dic 2010
# - Introduzione gestione installazione componenti

#VERSIONE=1.6.9 # lun 29 nov 2010
# - Introduzione gestione installazione componenti

#VERSIONE=1.6.8 # ven 26 nov 2010
# - Esternazione in un comando a se procedura si chmod/chown

#VERSIONE=1.6.7 # gio 25 nov 2010
# - Seconda Correzione Baco su bpsp EULA 
# - Gestione EULA multi-opzione.
# - Introduzione parte per Installazione di BPDS

#VERSIONE=1.6.6 # mer 24 nov 2010
# - Correzione Baco su bpsp EULA 

#VERSIONE=1.6.5 # mar 23 nov 2010
# - Gestione EULA per aggiornamento BPSP 
# - Gestione EULA per prodotto
# - Aggiunto parametro descrittore

#VERSIONE=1.6.4 # ven 19 nov 2010
# - Consento di proseguire con Bypass
# - Correzione frasi di log.

#VERSIONE=1.6.3 # mer 17 nov 2010
# - modificato uso mktemp per compatibilità vecchi linux
# - Modificato messaggio EULA
# - Attivazione stampa EULA

#VERSIONE=1.6.2 # lun 15 nov 2010
# - Introdotto parte di installazione per SP e DS
# - Modificato Traccia per leggere da stdin

#VERSIONE=1.6.1 # ven 12 nov 2010
# - Modificata gestione EULA

#VERSIONE=1.6.0 # mer 10 nov 2010
# - Eliminata la cartella msg (d.lesca @ solinos.it)
# - Aggiunta la gestione dell'EULA (d.lesca @ solinos.it)
# - Inserita la gestione per BPDS

#VERSIONE=1.5.3 # ven 5 nov 2010
# - Creazione file aincorso anche in installazione (d.lesca @ solinos.it)
# - Modificato sistema stop/start servizi (d.lesca @ solinos.it)

#VERSIONE=1.5.2 # mar 2 nov 2010
# - Aggiunta esecuzione makeconv per SP+DS (d.lesca @ solinos.it)
# - Aggiunta verifica versione descrittore (d.lesca @ solinos.it)
# - Unificato la verifica della cartella di inst/agg (d.lesca @ solinos.it)

#VERSIONE=1.5.1 # mar 28 ott 2010
# - Modificato test tipo_prodotto (d.lesca @ solinos.it)
# - Migliorata la visualizzazione delle opsioni. (d.lesca @ solinos.it)
# - Modificata procedura write_masterlog() (d.lesca @ solinos.it)
# - Modifica variabile tipo_bpoint in cod_supporto (d.lesca @ solinos.it)
# - Modifica opzione --tipo-bpoint in --prodotto (d.lesca @ solinos.it)
# - spostati controlli in file .ini (d.lesca @ solinos.it)

#VERSIONE=1.5.0 # mar 26 ott 2010
# - Incorporamento procedura install di B.Point (d.lesca @ solinos.it)
# - Gestione riconoscimento tipo B.Point (d.lesca @ solinos.it)

#VERSIONE=1.4.1 # mer 13 ott 2010
# - Gestione opzione '--tipo-bpoint' e controllo cartelle (d.lesca @ solinos.it)

#VERSIONE=1.4.0 # mar 12 ott 2010
# - Predisposta la funzione pper il log write_masterlog (d.lesca @ solinos.it)
# - Modificata opzione --setup-output (d.lesca @ solinos.it)
# - Corretto "if /" in awk cerca spazio (d.lesca @ solinos.it)

#VERSIONE=1.3.3 # lun 11 ott 2010
# - Migliorato file di log (d.lesca @ solinos.it)

#VERSIONE=1.3.2 # mar 05 ott 2010
# - Aggiustato gestione TEMPDIR (d.lesca @ solinos.it)
# - Aggiunta scrittura file di log globale (masterlog) (d.lesca @ solinos.it)
# - Aggiunta funzione cat_msg (d.lesca @ solinos.it)

#VERSIONE=1.3.1 # ven 01 ott 2010
# - modifica default cartella installazione (d.lesca @ solinos.it)
# - Gestione temp in filesystem più capiente (d.lesca @ solinos.it)

#VERSIONE=1.3.0 # mar 28 set 2010
# - Messapunto aggiornamento e installazione. (d.lesca @ solinos.it)

#VERSIONE=1.2.0 # lun 27 set 2010
# - Gestione impostazione accessi file (d.lesca @ solinos.it)
# - Gestione eventuali fix (d.lesca @ solinos.it)

#VERSIONE=1.1.0 # mar 31 ago 2010
# - Gestione controllo pacchi zip (d.lesca @ solinos.it)

#VERSIONE=1.0.0 # mar 20 lug 2010
# - Prima versione procedura (d.lesca @ solinos.it)

################################################

# Indispensabile un descrittore con versione (primo numero) maggiore o uguale a ...
VER_MIN_DESCRITTORE='2.1.0'

# Da dove sono lanciato.
MYROOT_DIR=$(cd "$(dirname "$0")";pwd -P)

# Io Sono
IO="$(basename "$0")"
#orig_setupdir=$(cd "$(dirname "$IO")";pwd)

# Funzione che scrive i parametri o l'imput nel file di log
# File di log delle operazioni.
SETUP_MASTERLOG=""
LAST_MASTERLOG=""
write_masterlog()
{
	# Data da inserire all'interno del file di log
	local log_prefix=$(LANG=C date '+%F-%H:%M:%S: ')
	local logcmd='tee /dev/fd/2'
	local stdout_prefix=''

	if [ -z "$SETUP_MASTERLOG" ]
	then
		# La prima volta che passo di qui
		local _base="/var/tmp/wkisetup"
		SETUP_MASTERLOG="$_base-$(date +%s).log"
		LAST_MASTERLOG="$_base-last.log"
		unset _base
	fi

	case "$1" in
	(--stdout-prefix)
		stdout_prefix=$2
		shift 1
		test $# -gt 0 && shift 1
	;;
	(--only-log)
		logcmd='cat'; shift 1
	;;
	(--init-file)
		rm -f "$SETUP_MASTERLOG" "$LAST_MASTERLOG"
		touch "$SETUP_MASTERLOG"
		ln -s "$SETUP_MASTERLOG" "$LAST_MASTERLOG"
		return 0
	;;
	(--get-filename)
		# Usare $(write_masterlog --get-filename)
		echo "$SETUP_MASTERLOG"
		return 0
	;;
	esac

	# Se non sono passati parametri leggo da stdinput, altrimenti visualizzo quanto passato.
	(test $# = 0 && cat || echo $*)|
		(eval $logcmd|sed "s/^/$log_prefix/" >> "$SETUP_MASTERLOG" ) 2>&1 |
		sed "s/^/$stdout_prefix/"

	return 0
}

# Procedura di uscita
function finito ()
{
	# Uscita senza messaggio
	local stat=0
	if [ -n "$1" ]
	then
		# Se si passa un messaggio significa che c'e' un errore quindi si esce con status errato
		(
		printf "$IO: $*\n"
		printf "$IO: Consultare il file di log [$(write_masterlog --get-filename)]\n"
		) | write_masterlog
		stat=2
	fi

	# Se esiste già la TEMP la rimuovo
	test -d "$MYTEMPDIR" &&
		rm -rf "$MYTEMPDIR"

	exit $stat
}

write_masterlog --init-file

write_masterlog --only-log "Avvio Operazioni di LOG..."

# Se mi interrompono...
trap "finito '\nInterruzione Manuale. Attendere ...'" 2 3 15

# Stringa Utilizzo
utilizzo="Utilizzo: $IO [opzioni] [cartella/file.zip di rilascio]\n"
utilizzo="$utilizzo	-h|--help				Questo messaggio\n"
utilizzo="$utilizzo	-v|--version				Indica la versione del la procedura\n"
utilizzo="$utilizzo	-d|--debug				Attiva opzioni di debug\n"
utilizzo="$utilizzo	-e|--accetto-la-EULA			Si accetta in automatico il Contratto di Licenza\n"
utilizzo="$utilizzo	-p|--prodotto {cod-prodotto}		B.Point da installare [bpsplnx|bpds] (def. AUTO)\n"
utilizzo="$utilizzo	-d|--descrittore {file descrittore}	Specifica il file descrittore da utilizzare\n"
utilizzo="$utilizzo	-S|--setup-dir {cartella setup}		Specifica la cartella in cui trovare la struttura setup\n"
utilizzo="$utilizzo	-a|--setup-auto {[i|a]:/cartella}	Azione e posizione da utilizzare\n"
utilizzo="$utilizzo	  |--extrazip-prima {pathzip [pathzip]	Elenco file zipo da installare/aggiornare prima degli altri\n"
utilizzo="$utilizzo	  |--extrazip-dopo  {pathzip [pathzip]	Elenco file zipo da installare/aggiornare dopo gli altri\n"
utilizzo="$utilizzo	  |--usa-postgress-standard		Utilizza componenti postgressql della distribuzione\n"
utilizzo="$utilizzo	-x|--proxy {http://user:pass@host:port}	URL proxy da utilizzare\n"
utilizzo="$utilizzo	[cartella o file.zip di rilascio]	dir/file da utilizzare (def. cartella corrente)"

getopt_short='h,v,D,e,p:,d:,S:,a:,x:'
getopt_longs='help,version,debug,accetto-la-EULA,usa-postgress-standard,prodotto:,descrittore:,setup-dir:,setup-auto:,extrazip-prima:,extrazip-dopo:,proxy:'

# Verifica opzioni
TEMP=$(getopt --options="$getopt_short" --longoptions="$getopt_longs" -n "$IO" -- "$@") ||
	finito "$utilizzo"

# Note the quotes around `$TEMP': they are essential!
eval set -- "$TEMP"

# Loggo le opzioni usate
write_masterlog --only-log "OPT=$TEMP"

# Gestione opzioni di default
DEBUG=''
setup_auto=''
cod_prodotto=''
file_descrittore=''
setupdir=''
accetto_la_EULA='no'
def_proxy=''
opt_pg_std=""
pkg_extrazip_prima=""
pkg_extrazip_dopo=""

echo "Caricamento procedura...."

# Analizzo le opzioni...
while [ "$1" != '--' ]
do
        case "$1" in
	(-h|--help)
		finito "$utilizzo"
	;;
	(-v|--version)
		finito "Versione $VERSIONE"
	;;
	(-D|--debug)
		DEBUG='DEBUG'
		shift
	;;
	(--usa-postgress-standard)
		opt_pg_std="$1" # imposto l'opzione --usa-postgress-standard
		shift
	;;
	(-e|--accetto-la-EULA)
		accetto_la_EULA='yes'
		shift
	;;
	(-a|--setup-auto)
		setup_auto=$2
		shift 2
	;;
	(-p|--prodotto)
		prodotto_richiesto=$2
		shift 2
	;;
	(-d|--descrittore)
		file_descrittore=$2
		shift 2
	;;
	(-S|--setup-dir)
		setupdir=$2
		shift 2
	;;
	(--extrazip-prima)
		pkg_extrazip_prima=$2
		shift 2
	;;
	(--extrazip-dopo)
		pkg_extrazip_dopo=$2
		shift 2
	;;
	(-x|--proxy)
		def_proxy=$2
		shift 2
	;;
	(*)
		finito "Errore gestione opzioni: 'case ($1)' assente!"
	;;
        esac
done
shift

#===============================================================================
# Verifico se sono 'root'
if [ ! -w /etc/passwd ]; then
	test "$DEBUG" = 'DEBUG' && cmd=echo || cmd=finito
	$cmd "Devi essere 'root' per poter eseguire questa procedura."
fi

#===============================================================================
# Verifico selinux
if selinuxenabled
then
	# selinux attivo
	finito "ATTENZIONE: SELinux attivo.\n" \
		"\tProcedere alla sua disattivazione (/etc/sysconfig/selinux)\n" \
		"\te riavviare il server prima di proseguire."
fi

#===============================================================================
# Verifico congruenza opzioni
if [ -z "$setup_auto" -a "$accetto_la_EULA" = 'yes' ]
then
	finito "Parametri errati:\n" \
		"\tl'opzione '--accetto-la-EULA' può essere\n" \
		"\tutilizzata solo con l'opzione '--setup-auto'"
fi

#===============================================================================
# Verifico se ho almento un parametro valido che indica il supporto da utilizzare
if [ -z "$1" ]
then
	# Se non viene passato un parametro assumo che mi trovo all'interno del supporto
	supporto=$MYROOT_DIR
else
	# OK.  Scarto questo parametro per usare eventualmente gli altri
	# Espando eventuali nomi di file relativi in assoluti.
	supporto=$1
	test ! -e "$supporto" &&
		finito "Il supporto inticato ($supporto) non esiste."

	supporto="$(cd "$(dirname "$supporto")";pwd -P)/$(basename "$supporto")"
	shift
fi

if [ -d "$supporto" ]
then
	# Se il supporto è una cartella non ho bisogno di tanto spazio per agire.
	basetmp='/var/tmp'
elif [ ! -f "$supporto" ]
then
	finito "Errore: supporto [$supporto] inesistente o incompatibile."
else
	# Se il supporto è un file(.zip) ho bisogno di tanto spazio per agire.
	# Verifico se lo spazio c'e' e dove si trova
	basetmp=''

	# Carlcolo lo spazio necessario... il doppio dello zip.
	spazio_ric=$[$(ls -s "$supporto"|sed 's/ .*//') * 2]

	# Verifico se lo spazio necessario e' disponibile, prima sotto la var e u, poi negli altri fs
	# NOTA: non sono gestiti FS con caratteri speciali o spazi
	fs_all_dir="/var/ / /u/ $(df --portability|awk '$4~/^[0-9]*$/ && $6!="/" && $6!="/var" {printf("%s/ ",$6)}')"

	#TODO: gestire meglio l'impostazione della tmp per / e /var

	# Per ogni file system montato ....
	for fs_dir in $fs_all_dir
	do
		# Verifico se in questo FS posso scrivere, altrimenti lo scarto
		test ! -w "$fs_dir" &&
			continue

		# Verifico se in questo FS ci sto'... 
		basetmp="$(df --portability "$fs_dir" 2>/dev/null |
			awk -v sr="$spazio_ric" '$4~/^[0-9]*$/ && $4>sr {if($6!="/"){ b="/"}; print $6 b "tmp";exit}')"

		# Se ci stà ritorna il nome del FS + /tmp
		if [ -n "$basetmp" ]
		then
			# Ok, ci stà, se non c'e' mi faccio un tmp per non sporcare la root del filesstem
			if [ ! -d "$basetmp" ]
			then
				mkdir -m 777 "$basetmp"
			fi

			# Ok, ho trovato e fatto. Smetto di cercare.
			break
		fi
	done

	# Se non ho trovato spazio ... si esce.
	test -z "$basetmp" &&
		finito "Errore:\n" \
			"\tIn nessun filesystem, accessibile in modalità write,\n" \
			"\tsono disponibili $spazio_ric KB di spazio libero"
fi
# definisco la cartella TEMP da utilizzare (adattato per compatibilità vecchi sistemi)
MYTEMPDIR="$(TMPDIR="$basetmp" mktemp -d -t "wkitemp.XXXXXXXXXX")"
# MYTEMPDIR="$(mktemp -d -p "$basetmp" "wkitemp.XXXXXXXXXX")"

# Scrivo la temp nel file di log ... magari servita'
write_masterlog --only-log "MYTEMPDIR=$MYTEMPDIR"

# Procedura che ritorna il path del file zip specificato
# Nel caso il fila sia in un file zip questo vene estratto in tmp
zipcheck_getpath()
{
	test $# -lt 2 &&
		finito "Errore: zipcheck_getpath: parametri errati. (zipcheck_getpath [--test] {supporto} {file.zip})"

	local testpk='no'
	if [ "$1" = '--test' ]
	then
		testpk='yes'
		shift
	fi
	local supporto="$1"
	local file_zip="$2"
	local st=1
	local pathzip=""

	# Verifico se mi hanno passato:
	#	a) uno zip col path assoluto
	#	b) un file pacco.zip
	#	c) una cartella contenente il pacco.zip
	if [ "$testpk" = 'yes' ]
	then
		# Per default ritorno che no, non c'e'
		st=1
		if [ "${file_zip:0:1}" = '/' -a -f "$file_zip" ]
		then
			# Passato un file zip con path assoluto
			st=0
		elif [ -f "$supporto" ]
		then
			# Passato un supporto zip contenitore.
			# Verifico se contiene il file
			if unzip -qq -l "$supporto" 2>/dev/null | grep -q " $file_zip\$"
			then
				st=0
			fi
		elif [ -d "$supporto" ]
		then
			# Passato una cartella contenente gli zip, vediamo se c'e'
			if [ -f "$supporto/$file_zip" ]
			then
				st=0
			fi
		fi
	else
		# Verifico se mi hanno passato a)uno zip col path assoluto o b)un file pacco.zip o c)una cartella contenente il pacco.zip
		if [ "${file_zip:0:1}" = '/' -a -f "$file_zip" ]
		then
			# Passato un file zip con path assoluto
			pathzip='/'
		elif [ -f "$supporto" ]
		then
			# Passato un supporto zip contenitore.
			# Estraggo dal contenitore zip il file .zip indicato
			unzip -q "$supporto" "$file_zip" -d "$MYTEMPDIR" 1>&2 </dev/null
			pathzip="$MYTEMPDIR/"
		elif [ -d "$supporto" ]
		then
			# Passato una cartella contenente gli zip
			pathzip="$supporto/"
		else
			# No file, no cartella ... chissa cosa mi hanno passato...
			pathzip=''
		fi

		# Verifico se ho un path e se il file cercato ora c'e' nella cartella passata o estratta
		if [ -n "$pathzip" -a -f "$pathzip$file_zip" ]
		then
			# Ritorno il path+file o nulla
			echo "$pathzip$file_zip"
			st=0
		else
			# Non Ritorno nulla e con status errato
			st=1
		fi
	fi

	return $st
}

if [ -z "$setupdir" ]
then
	# Ricavo il path del file eventualmente estraendolo dal pacco
	setupzip="$(zipcheck_getpath "$supporto" "setup.zip")"

	# Verifico se alla fine ho trovato il mio setup.zip
	if [ ! -f "$setupzip" ]
	then
		# Il file non c'e'
		finito "Errore: Tipo Supporto di Distribuzione ($supporto) non corretto o inesistente.\n$utilizzo"
	fi

		
	# Estraggo la procedura di setup
	setupdir="$MYTEMPDIR/setup"
	unzip -q "$setupzip" -d "$setupdir" </dev/null
fi

# Verifico se sono a casa
if [ ! -d "$setupdir/db/" ]
then
	finito "Errore: Struttura setup danneggiata (manca $setupdir/db/)."
fi

if [ -n "$file_descrittore" ]
then
	# Descrittore passato
	descrini="$file_descrittore"
else
	# Descrittore contenuto nel file di ini
	descrini="$setupdir/descrittore.ini"
fi

# Verifico se ho tutto
if [ ! -r "$descrini" ]
then
	finito "Errore: File $descrini non trovato o inaccessibile."
fi

#===============================================================================
# Valorizzo ulimit e umask in modo appropriato
# ulimit	200000
ulimit unlimited

umask 	0000

# Imposto la PATH in modo da cercare prima nella cartella in cui mi trovo, poi nella setup dir
export PATH="$PATH:$MYROOT_DIR/cmd:$MYROOT_DIR/bin:$setupdir/cmd/:$setupdir/bin"

# opzionale: Aggiungo per DEBUG anche la cartella cmd di setup.sh usato
#export PATH="$orig_setupdir/cmd:$PATH"

# Ci entro ...
cd "$setupdir"

# Verifico la versione del descrittore utilizzato...
ver_descrittore=$(readfileini.sh --value-no-quote "$descrini" 'globale.ver_descrittore')
# Converto in un formato numerico eliminando i punti
cmpt_ver_cur=$(echo "${ver_descrittore}"|sed 's/\.//g')
cmpt_ver_min=$(echo "${VER_MIN_DESCRITTORE}"|sed 's/\.//g')
if [ "$cmpt_ver_cur" -lt "$cmpt_ver_min" ]
then
	finito "Errore:\n" \
		"  Questa versione di setup.sh ($VERSIONE) non è compatibile\n" \
		"  con la versione del descrittore utilizzato ($ver_descrittore).\n" \
		"  si richiede una versione di descrittore uguale o superiore a $VER_MIN_DESCRITTORE"
fi

# Informo sul tipo di supporto
write_masterlog --only-log "Tipo Prodotto richiesto \$prodotto_richiesto=[$prodotto_richiesto]."

#===============================================================================
# Verifico il tipo di supporto utilizzato nel caso non sia specificato (AUTO)
linux_supp_auto=$(readfileini.sh --value-no-quote "$descrini" 'linux.supporti_auto')
if [ -z "$prodotto_richiesto" ]
then
	# Se non è stato specificato alcun prodotto lo ricavo analizzando il supporto passato
	cod_prodotto="$linux_supp_auto"
else
	# Utilizzo il prodotto indicato, se c'è
	echo " $linux_supp_auto " | grep -q " $prodotto_richiesto " ||
		finito "Errore codice prodotto '$prodotto_richiesto' non trovato tra i seguenti:\n"\
			"\t[ $linux_supp_auto ]"
	cod_prodotto="$prodotto_richiesto"
fi

# Verifico se il prodotto o i prodotti specificati sono copatibili sol supporto utilizzato.
for cod_prodotto in $cod_prodotto
do
	# Per ogni pacco utilizzato da questo prodotto verifico se esiste o no
	for pkg in $(readfileini.sh --value-no-quote "$descrini" "$cod_prodotto.pkg_lista_agg")
	do
		# Verifico se il pacco esiste o no nella cartella/file di distribuzione
		if ! zipcheck_getpath --test "$supporto" "$pkg"
		then
			# Se questo pkg richiesto non esiste in questo pacco
			# Vuol dire che questo NON un prodotto compatibile.
			cod_prodotto=''
			# Esco e passo al prodotto successivo
			break
		fi
	done
	if [ -n "$cod_prodotto" ]
	then
		# OK, al primo trovato esco.
		break
	fi
done

if [ -z "$cod_prodotto" ]
then
	if [ -n "$prodotto_richiesto" ]
	then
		finito "Errore: codice prodotto ($prodotto_richiesto) non trovato all'interno del supporto.\n"
	else
		finito "Errore: nessuno dei seguenti codici prodotto è stato trovato nel supporto:\n"\
			"\t[ $linux_supp_auto ]"
	fi
fi

#===============================================================================
# Leggo i valori dal file ini
edz_tipo=$(readfileini.sh --value-no-quote "$descrini"		'globale.edz_tipo')

aggio_mklogin=$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.aggio_mklogin")
test -z "$aggio_mklogin" &&
	aggio_mklogin=$(readfileini.sh --value-no-quote "$descrini"	'linux.aggio_mklogin')

run_primasetup="$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.run_primasetup")"
run_doposetup="$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.run_doposetup")"

# Valori basati sul prodotto
sisdesc=$(readfileini.sh --value-no-quote "$descrini"		"$cod_prodotto.pkg_descrizione")

# Tipo Versione prodotto, vale SP o DS
tipo_ediz_ver=$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.tipo_ediz_ver")
test -z "$tipo_ediz_ver" &&
	tipo_ediz_ver='SP' # questo il default
edz_version=$(readfileini.sh --value-no-quote "$descrini"	"globale.edz_version_$tipo_ediz_ver")
edz_aggiornabili=$(readfileini.sh --value-no-quote "$descrini"	"globale.edz_aggiornabili_$tipo_ediz_ver")
file_versione=$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.file_versione")
test -z "$file_versione" &&
	file_versione='etc/sisver' # questo il default

deve_esserci="$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.deve_esserci")"
subpkg_dir="$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.subpkg_dir")"
system_user=$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.system_user")
def_sisprg=$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.def_sisprg")

#===============================================================================
# Gestione EULA per prodotto

# Cerco prima nel prodotto poi nei globali
for val in "$cod_prodotto" 'globale'
do
	# Flag se devo visualizzare oppure no
	test -z "$EULA_visualizza" &&
		EULA_visualizza=$(readfileini.sh --value-no-quote "$descrini" "$val.EULA_visualizza")

	# Nome del file, è privo dell'estensione
	test -z "$EULA_nomefile" &&
		EULA_nomefile=$(readfileini.sh --value-no-quote "$descrini" "$val.EULA_nomefile")
done

# Se non trovo, ecco il default.
test -z "$EULA_visualizza" &&
	EULA_visualizza='yes'

# Aggiungo l'estensione se il nome è presente...
test -n "$EULA_nomefile" &&
	EULA_nomefile="$EULA_nomefile.txt"

#===============================================================================
# Visualizza messaggio di setup (msg/)
cat_msg() {
	cat msg/$* | write_masterlog
	return 0
}

# Procedura che verifica lo stato della cartella di inst o agg
# per la parte automatica e interattiva
ver_bpointprg()
{	
	local rootbp=$1

	# Verifico congruenza cartella ...
	case "$ins_agg" in
	(aggiornamento)

		# Verifico che esistano le cartelle principali di B.Point
		if [ ! -d "$rootbp/prg/etc" -o ! -d "$rootbp/prg/cmd" -o ! -d "$rootbp/prg/com" ]
		then
			echo "Errore:\n" \
				"\tSi tenta di effettuare un aggiornamento in [$rootbp]\n" \
				"\tma non esistono le cartelle principali del prodotto."
			return 1
		fi

		# Verifico l'esistenza di cartelle o file se richiesto
		for loc_deve_esserci in $deve_esserci $subpkg_deve_esserci
		do
			if ! echo $loc_deve_esserci | grep -q '^/' 
			then
				# Se par relativo lo rendo assoluto
				loc_deve_esserci="$rootbp/$loc_deve_esserci"
			fi
			if [ ! -e "$loc_deve_esserci" ]
			then	
				echo "Errore:\n" \
					"\tSi tenta di effettuare un aggiornamento in [$rootbp]\n" \
					"\tma non esiste [$loc_deve_esserci]."
				return 1
			fi
		done

		# Verifico che esistano le cartelle principali di B.Point
		if [ ! -d "$rootbp/prg/etc" -o ! -d "$rootbp/prg/cmd" -o ! -d "$rootbp/prg/com" ]
		then
			echo "Errore:\n" \
				"\tSi tenta di effettuare un aggiornamento in [$rootbp]\n" \
				"\tma non esistono le cartelle principali del prodotto."
			return 1
		fi

		# Verifico la versione installata se compatibile
		if [ ! -f "$rootbp/prg/$file_versione" ]
		then
			echo "Errore:\n" \
				"\tFile di controllo versione [$rootbp/prg/$file_versione] assente."
			return 1
		fi

		# Verifico la versione installata se compatibile
		if ! versisver "$rootbp/prg/$file_versione" "$edz_aggiornabili"
		then
			echo "Errore:\n" \
				"\tSi tenta di effettuare l'aggiornamento su una versione\n" \
				"\tdi B.Point ($(sed -e 's/\r$//' -e 1q "$rootbp/prg/$file_versione")) non compatibile con il\n" \
				"\tsupporto utilizzato ($edz_aggiornabili)."
			return 1
		fi
	;;
	(installazione)
		if [ "$rootbp" = '/' ]
		then
			echo "Errore:\n" \
				"\tSi tenta di effettuare un installazione\n" \
				"\tnella root del sistema ('/')."
			return 1
		fi

		if [ "${rootbp:0:1}" != '/' ]
		then
			echo "Errore:\n" \
				"\tSi tenta di effettuare un installazione\n" \
				"\tma il pathname indicato non inizia con '/'."
			return 1
		fi

		if echo "$rootbp"|grep -E -q '/\.\.'
		then
			echo "Errore:\n" \
				"\tSi tenta di effettuare un installazione\n" \
				"\tma il pathname indicato contiene '/..'."
			return 1
		fi

		if [ "$(printf "$rootbp"|sed -e 's|/*$||' -e 's|[^/]||g'|wc -c)" -lt 2 ]
		then
			# verifico che il path sia almeno di 2 cartelle
			echo "Errore:\n" \
				"\tSi tenta di effettuare un installazione\n" \
				"\tin una cartella contenuta nella root ('/') del sistema."
			return 1
		fi

		if [ -e "$rootbp" -a ! -d "$rootbp" ]
		then
			echo "Errore:\n" \
				"\tSi tenta di effettuare un installazione\n" \
				"\te l'elemento indicato ($rootbp) NON è una cartella."
			return 1
		fi

		# Non esiste nemmeno la cartella padre
		if [ ! -e "$rootbp" -a ! -d "$(dirname "$rootbp")" ]
		then
			echo "Errore:\n" \
				"\tSi tenta di effettuare un installazione\n" \
				"\te il pathname indicato ($rootbp) NON è corretto."
			return 1
		fi

		if [ -e "$rootbp" ]
		then
			# Verifico se devo gestire un pacchetto aggiuntivo (subpkg)
			if [ -z "$subpkg_dir" ]
			then
				# Nessun subpkg ed Esiste: verifico che non sia piena
				if [ $(ls -la "$rootbp"|wc -l) -gt '3' ]
				then
					echo "Errore:\n" \
						"\tSi tenta di effettuare un installazione\n" \
						"\te la cartella indicata ($rootbp) NON è vuota."
					return 1
				fi
			else
				# Verifico che NON esista il sub pkg
				if [ -d "$rootbp/$subpkg_dir" ]
				then
					echo "Errore:\n" \
						"\tSi tenta di installare un componente aggiuntivo\n" \
						"\te l'oggetto indicato ($rootbp/$subpkg_dir) esiste."
					return 1
				fi
			fi
		fi
	;;
	(*)
		echo "Errore: ... che ci faccio qui???"
		return 1
	;;
	esac

	return 0
}

# Procedura che indica cosa sto facendo.
Traccia() {
	case "$1" in
	(--sub)
		shift
		prefix='\t  . '
	;;
	(*)
		prefix='\t- '
	;;
	esac
	if [ $# = 0 ]
	then
		cat
	else
		echo $*
	fi |
	write_masterlog --stdout-prefix "$prefix" $*
}

# Gestione EULA
visualizza_EULA()
{
	local risposta='no'

	# Valori ammessi per EULA_visualizza:
	#   no, i(si for inst), a(si for agg), e|si|yes(si for i/a)
	case "$EULA_visualizza:$ins_agg" in
	(no:*|a:i*|i:a*)
		# Non devo visualizzare la EULA
		return 0
	;;
	(*)
		if [ ! -e "$EULA_nomefile" ]
		then
			finito "Errore:\n" \
				"	Si richiede la visualizzazione del Contratto di licenza\n" \
				"	ma il file [$EULA_nomefile] non esiste o non è impostato."
		fi
	;;
	esac

	test "$1" = '--no-question' &&
		risposta='si'

	while [ "$risposta" != 'si' ]
	do
		tput clear
		echo "------------------------------"
		echo "[$sisdesc]"
		echo
		echo    "Visualizzazione del Contratto di Licenza."
		echo    "  NOTA: Per terminare la consultazione del Contratto"
		echo    "  di Licenza premere la lettera 'q' o 'Q'."
		read -p "Premere invio per proseguire..." risposta
		echo
		case "$risposta" in
		('X')
			# UNDOCUMENTED: Fatto ad uso interno, per saltare la richiesta di EULA.
			risposta='si'
		;;
		('SH'|'sh')
			bash
		;;
		(*)
			risposta=''
			# Visualizzo contratto di licenza
			less --prompt="Premi 'q' o 'Q' per uscire." "$EULA_nomefile"

			echo "Il Contratto di Licenza è stato visualizzato. Sarà possibile"
			echo "consultarlo ed eventualmente stamparlo successivamente."
			echo
			echo "Azioni disponibili."
			echo
			echo "  Digitare 'si' per proseguire e accettare i termini di licenza."
			echo "  Digitare 'no' per abbandonare e rifiutare i termini di licenza."
			echo "  Digitare 'lp {prX}' per stampare il contratto sulla stampante 'prX'."
			echo "  Premere <INVIO> per visualizzare nuovamente il Contratto."
			echo ""
			read -p "Selezione: " risposta
		;;
		esac

		case "$risposta" in
		(no)
			finito "Rifiutati i Termini di licenza. Procedura annullata."
		;;
		(lp*) 
			echo
			echo "Stampanti disponibili:"
			lpstat -v 2>&1|sed 's/^/ - /'
			lpx=$(echo ${risposta##lp}) # per pulire blank iniziali
			if test -z "$lpx"
			then
				a=""
			else
				if lpstat -v|awk '{print $3}' | grep -q "$lpx:"
				then
					a="Digita 'OK' avviare la stampare su '$lpx'. "
				else
					a="Stampante '$lpx' inesistente. "
				fi
			fi
			read -p "${a}Premi <invio> per continuare: " a
			if [ -n "$lpx" -a "$a" = 'OK' ]
			then
				unix2dos < "$EULA_nomefile" | lp -d "$lpx"
				read -p "Premi <invio> per continuare: " a
			fi
		;;
		esac

	done
	echo

	# echo "Termini di licenza accettati."

	return 0
}

# Procedura che esegue shell prime e dopo
run_subsetupcmd()
	# Pre e postinstall
{
	local cmd=$1
	
	# Visualizzo eventuali messaggi un livello sotto al messaggio traccia.
	(
		# Eseguo il comando, visualizzo l'ouput e memorizzo eventuali errori
		eval "$cmd" 2> "$MYTEMPDIR/run_doposetup.log"
		st=$?

		# Loggo nel log il comando, eventuali errori e lo status
		(
		echo "[$cmd]"

		cat "$MYTEMPDIR/run_doposetup.log"

		echo "Status=$st"
		) | write_masterlog --only-log

	) | Traccia --sub
	
	return 0
}

setup_wkicosimi ()
{
	# Procedura per SmartDS - creazione file e caertelle per BPDS

	local bp_root=$1

	local bp_prg="$bp_root/prg"

	local writefile=""

	if [ ! -d "$bp_prg" ]
	then
		echo "$0: setup-wkicosimi: Cartella '$bp_prg' inesistente!"
		return 2
	fi

	local wki_root=$(dirname "$bp_root")

	Traccia --sub "Creo la struttura cartelle wkicosimi ..."
	# Inizializzazione directories
	for i in wkicosimi wkicosimi/wsiotemp wkicosimi/wsiotemp/log \
		wkicosimi/bin wkicosimi/bpoint wkicosimi/bpoint/bin
	do
		mkdir -p $wki_root/$i
		chmod 777 $wki_root/$i
	done

	# Inizializzazione di alcuni file XML di configurazione

	BPOINT_NAME='BPOINT' # Definitivo (29/10/2012)

	# wkisuite.config.xml
	writefile="$wki_root/wkicosimi/wkisuite.config.xml"
	if [ ! -r "$writefile" ]
	then
		Traccia --sub "Scrivo il file [$writefile] ..."
		cat $bp_prg/com/start/wkisuite.template |
		sed -e "s|name=\"BPOINT\"|name=\"$BPOINT_NAME\"|g" |
		sed -e "s|PATH_APP|$wki_root/wkicosimi/bpoint|g" |
		sed -e "s|PATH_SISTINFO|$wki_root/bpoint|g" > "$writefile"
		chmod 777 "$writefile"
	fi
	( ls -l "$writefile") | write_masterlog --only-log

	# wkisuite.schema.xsd
	writefile="$wki_root/wkicosimi/wkisuite.schema.xsd"
	if [ ! -r "$writefile" ]
	then
		cp $bp_prg/com/start/wkisuite.schema.xsd "$writefile"
		chmod 777 "$writefile"
	fi
	( ls -l "$writefile") | write_masterlog --only-log

	# productcountryinfo.IT.it-IT.xml
	writefile="$bp_prg/com/bpoint/initdata/productcountryinfo.IT.it-IT.xml"
	if [ ! -r "$writefile" ]
	then
		echo "<root country='IT' />" > "$writefile"
		chmod 777 "$writefile"
	fi
	( ls -l "$writefile") | write_masterlog --only-log

	# Fine
	writefile=""

}

###################################################################
#
# AVVIO PROCEDURA
#
###################################################################

# Loggo tutte le variabili come sono settate prima di partire
(
	exec 2>&1

	echo "Versione setup $VERSIONE ($VER_DATE)."
	ls -l "$MYROOT_DIR/$IO"
	for cmd in \
		'readfileini.sh' \
		'restart-srv.sh' \
		'rm-obsoleti.sh' \
		'setup-chperm.sh' \
		'setup-bp-component.sh' \
		'setup-bp-dbpsql.sh' \
		'versisver' \
	;do
		ls -l "$(which "$cmd")"
	done
	echo

	echo "Informazioni sul Sistema Operativo:"
	set -x
	w
	cat /etc/issue
	uname -a
	df -h
	rpm -qa '*mono-*' 'libgdiplus-*' 'xsp'

	set +x
	echo

	echo "Variabili d'ambiente:"
	env | LANG=C sort
	echo

	echo "========================================="
) | write_masterlog --only-log

# Preparazione parametri Automatici o Interattivi
if [ -n "$setup_auto" ]
then
	# Aggiornamento/Installazione automatica, tramite sispac, parametri passati

	# Inst o Agg
	ins_agg=${setup_auto%%:*}
	# cartella
	BPOINT_ROOT=$(echo "${setup_auto##*:}"|sed 's|/*$||')

	# Aggiusto l'opzione se è il caso
	case "$ins_agg" in
	(i*) ins_agg='installazione' ;;
	(a*) ins_agg='aggiornamento' ;;
	(*)
		finito "Errore: parametro per setup_auto errato ($ins_agg)"
	;;
	esac

	# Controllo congruenza parametri
	case "$edz_tipo:$ins_agg" in
	(entrambi:installazione) : ;;
	(entrambi:aggiornamento) : ;;
	(installazione:installazione) : ;;
	(aggiornamento:aggiornamento) : ;;
	(automatico:*)
		Traccia "AVVERTENZA:"
		Traccia --sub "Tipo edizione (edz_tipo) impostato su [$edz_tipo]."
		Traccia --sub "Verrà impostato su [$ins_agg]."
		edz_tipo=$ins_agg
	;;
	(*)
		finito "Errore: \n" \
			"	Operazione di $ins_agg non possibile con questo supporto.\n" \
			"	Oppure parametro installazione/aggiornamento non corretto ($edz_tipo:$ins_agg)."
	;;
	esac

	msg=$(ver_bpointprg "$BPOINT_ROOT")
	test -n "$msg" &&
		finito $msg

else
	# Aggiornamento/Installazione interattiva.

	if [ -z "$system_user" -o -z "$def_sisprg" ]
	then
		# Probabilmente un prodotto che può solo essere aggiornato.
		finito "Errore: valore system_user o def_sisprg non previsti per l'installazione"
	fi
	
	#===============================================================================
	# Visualizzazione Contratto di licenza

	visualizza_EULA

	tput clear
	echo
	echo "	Procedura di Setup Prodotti WKI (Ver.: $VERSIONE)"
	echo
	echo "	Prodotto: $sisdesc"
	echo "	Release : $edz_version"
	echo

	#===============================================================================
	# Tramite il file tipoemis so se e` installabile, aggiornabile o entrambi.

	ins_agg=""
	while [ "$ins_agg" != "installazione" -a "$ins_agg" != "aggiornamento" ]
	do
		echo
		echo "	-[ SCELTA OPERAZIONE ]----------------------------------------------"
		echo

		case "$edz_tipo" in
		(installazione)
			echo "	Il supporto utilizzato puo' essere utilizzato"
			echo "	esclusivamente per effettuare un INSTALLAZIONE"

			ins_agg='installazione'
		;;
		(aggiornamento)
			echo "	Il supporto utilizzato puo' essere utilizzato"
			echo "	esclusivamente per effettuare un AGGIORNAMENTO"

			ins_agg='aggiornamento'
		;;
		(entramb*)
			echo "	Il supporto di installazione in uso puo' essere utilizzato"
			echo "	sia per effettuare un INSTALLAZIONE che un AGGIORNAMENTO."
		;;
		(automatico)
			echo "	NOTA: Il valore 'automatico' impostato in 'edz_tipo'"
			echo "	non è previsto in quanto utilizzato dal sistema di"
			echo "	di preparazione supporti che lo imposta con uno dei"
			echo "	valori previsti (inst|agg|entrambi)"
		;;
		(*)
			finito "Errore: valore non previsto di edz_tipo ($edz_tipo)"
		;;
		esac

		if [ -z "$ins_agg" ]
		then
			echo ""
			echo "	Indicare quale operazione si intende effettuare."
			echo ""
			read -p "	- (I)nstallazione (A)ggiornamento: " a

			case $a in
			I*|i*) 
				ins_agg='installazione'
				# Verifico sistema operativo
				_ifs=$IFS

				IFS=:
				chklinuxver=(`checklinuxver.sh --controlla-versione`)
				tmp_edz_version = $edz_version
				# In caso di DS deve essere portata la release all'equivalente
				# di SP poiche' il controllo dei sistemi operativi e' basato
				# sulla release di SP. es. 13.10.00DS deve diventare 18.10.00SP
				if [ "$tipo_ediz_ver" == "DS" ]
				then
					tmp_release_calc="${edz_version:0:2}" 
					tmp_edz_version=$(expr $tmp_release_calc + 5)
					tmp_edz_last="${edz_version: -6}"
					tmp_edz_version=$tmp_edz_version$tmp_edz_last
				fi
				if [[ "$tmp_edz_version" > "${chklinuxver[3]}" ]]
				then
					finito "\n\nSistema operativo non certificato!\n" \
						"\tNon e' possibile proseguire, perche'\n" \
						"\til sistema '${chklinuxver[1]}'\n" \
						"\tnon e' supportato per le nuove installazioni!"
				fi
				IFS=$_ifs
			;;
			A*|a*) ins_agg='aggiornamento' ;;
			*) ins_agg='' ;;
			esac
		fi
	done
	echo

	# Valore i o a scritto in maiuscolo
	I_A="$(echo $ins_agg|dd conv=ucase 2>/dev/null)"

	#===============================================================================
	# Assumo i default per prg.

	BPOINT_ROOT=`awk -F: -v user=$system_user '$1==user {print $6}' /etc/passwd | sed 's/\/prg$//'`
	if [ "$BPOINT_ROOT" = "" ]
	then
		BPOINT_ROOT=$def_sisprg
	fi

	#===============================================================================
	# Richiesta delle directoryes in cui installare i programmi e gli archivi
	while [ true ]
	do
		nopath=""

		echo
		echo "	-[ SCELTA CARTELLA ]---------------------------------------------"
		echo
		echo "	Indicare il Pathnames nel quale si intende effettuare"
		echo "	l'operazione di $I_A."
		echo
		read -p "	Cartella ($BPOINT_ROOT):  " a

		case "$a" in
		(SHELL)
			/bin/sh
			continue
		;;
		("")
			a=$BPOINT_ROOT
		;;
		esac

		msg=$(ver_bpointprg "$a")

		if [ -n "$msg" ]
		then
			# Il path non va bene, visualizzo l'errore
			printf "\n\t$msg\n\n"
		else
			# Il path va bene, esco
			BPOINT_ROOT=$(echo "$a"|sed 's|/*$||')
			break
		fi
	done

	#===============================================================================
	# Verifico se devo impostare il proxy (nel caso mi anchino componenti)
	if [ "$ins_agg" = "aggiornamento" ]
	then
		# In aggiornamento
		st=0
	else
		# In installazione 
		(
		exec 2>&1
		eval setup-bp-component.sh "--prod=$cod_prodotto" --test $opt_pg_std >/dev/null
		) | write_masterlog --only-log
		st=$?
	fi
	# Status 1 indica che occorre installare i componenti
	while [ "$st" = '1' ]
	do
		echo
		echo "	-[ IMPOSTAZIONE PROXY ]-------------------------------------------"
		echo
		echo "	Sarà indispensabile installare alcuni componenti di sistema."
		echo "	Se necessario, indicare il proxy da utilizzare."
		echo "	Alcuni esempi:"
		echo "		(http://proxy:8080)"
		echo "		(https://secure-proxy:3128)"
		echo "		(http://user:pass@proxy:3128)"
		echo
		read -p "	Premere invio per procedere senza proxy: " def_proxy
		case "$def_proxy" in
		(http*://*)
			echo "	Proxy ftp,http e https impostato a [$def_proxy]."
			break
		;;
		("")
			echo "	Nessun proxy impostato."
			def_proxy=''
			break
		;;
		esac
		echo
	done

	#===============================================================================
	# Prima di procedere chiedo ulteriore conferma
	a=""
	while [ "$a" != "OK" ]
	do
		echo
		echo "	-[ CONFERMA SELEZIONI ]------------------------------------------------"
		echo 
		echo "	Raccolta dati terminata."
		if [ -z "$subpkg_dir" ]
		then
			echo "	Esecuzione $I_A di '$sisdesc'"
			echo_dirinst=$BPOINT_ROOT
		else
			echo "	Esecuzione $I_A pacchetto aggiuntivo"
			echo "		[$sisdesc]"
			echo_dirinst="$BPOINT_ROOT/($subpkg_dir)"
		fi
		echo "	Cartella di installazione: [$echo_dirinst]"
		if [ -n "$def_proxy" ]
		then
			echo "	Proxy utilizzato: [$def_proxy]."
		fi
		echo 
		echo "	Digitare 'OK' per procedere oppure 'Q' per abbandonare."
		echo
		read -p "	Selezione: " a
		test "$a" != 'OK' &&
			finito "Procedura Interrotta."
	done
	echo 

fi

#===============================================================================
# Procedo con agg./inst.

# Prendo il tempo di quando parto....
data_start=$(date +%s)

#===============================================================================
# Verifico se devo creare la cartella in cui installare
if [ "$ins_agg" = "installazione" ]
then
	# Va bene, si prosegue, se non c'e creo la cartella
	test ! -d "$BPOINT_ROOT" &&
		mkdir "$BPOINT_ROOT"
fi

#===============================================================================
# da BPOINT_ROOT tolgo '..' per ottenere, per esempio, /u/wki
WKI_ROOT=$( cd "$BPOINT_ROOT/.."; pwd )
BPOINT_PRG="$BPOINT_ROOT/prg"

#===============================================================================
# Imposto il proxy
if [ -n "$def_proxy" ]
then
	export ftp_proxy="$def_proxy"
	export http_proxy=$def_proxy
	export https_proxy=$def_proxy
fi

#===============================================================================
# Verifico se ho le cartelle che mi servono e che tipo di prodotto sono

# Per default sono su un prodotto singolo e non uso eccezioni ...
keypref=''

if [ "$ins_agg" = "aggiornamento" ]
then
	# Eccezione speciale per SP+DS, si attiva solo se inizializzata la chiave spds_se_esiste
	se_esiste="$(readfileini.sh --value-no-quote "$descrini"  "$cod_prodotto.spds_se_esiste")"
	if [ -n "$se_esiste" ]
	then
		if ! echo $se_esiste | grep -q '^/' 
		then
			# Se path relativo lo converto in assoluto
			se_esiste="$BPOINT_ROOT/$se_esiste"
		fi
		if [ -e "$se_esiste" ]
		then	
			# Sono su un SPDS
			keypref='spds_'
		fi
	fi
fi

# Assegno e Ri-assegno i valori dipendenti dal prodotto che sto' inst/agg ... ando.
system_user=$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.${keypref}system_user")
all_sys_users=$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.${keypref}all_sys_users")
all_rest_wki_srv=$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.${keypref}all_rest_wki_srv")
all_inst_wki_srv=$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.${keypref}all_inst_wki_srv")
esegui_makeconv=$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.${keypref}esegui_makeconv")
verifica_licenza=$(readfileini.sh --value-no-quote "$descrini"	"$cod_prodotto.${keypref}verifica_licenza")

# Ricarico il valore in base alla situazione che si è venura a ricreare.
EULA_visualizza=$(readfileini.sh --value-no-quote "$descrini" "$cod_prodotto.${keypref}EULA_visualizza")
test -z "$EULA_visualizza" &&
	EULA_visualizza='yes'

#==================================================================================
(
# Un po di loggin
echo "Valori descrittore"
echo "------------------------------------------------------"
cat "$descrini"
echo "------------------------------------------------------"
echo "Tipo Supporto (cod_prodotto) [$cod_prodotto]"
echo "pre-chiave keypref=$keypref"
echo " - system_user=$system_user"
echo " - all_sys_users=$all_sys_users"
echo " - all_rest_wki_srv=$all_rest_wki_srv"
echo " - all_inst_wki_srv=$all_inst_wki_srv"
echo " - esegui_makeconv=$esegui_makeconv"
echo " - verifica_licenza=$verifica_licenza"
echo " - EULA_visualizza=$EULA_visualizza"
) | write_masterlog --only-log

if [ -n "$setup_auto" ]
then
	# Visualizzo il Contratto di Licenza d'uso
	if [ "$accetto_la_EULA" = 'yes' ]
	then
		# Usata l'opzione silente
		visualizza_EULA --no-question
	else
		visualizza_EULA
	fi
fi

#===============================================================================
# Verifico su bpDS che sia impostato un LANG in UTF-8 in fase di installazione
if [ "$cod_prodotto" = 'bpds' -a "$ins_agg" = "installazione" ]
then
	f_18='/etc/sysconfig/i18n'
	f_pg='/var/lib/pgsql/data/postgresql.conf'
	test -f "f_18" && if ! grep -q 'LANG=.*it_IT.' $f_18
	then
		finito "ATTENZIONE:\n" \
			"\tValore \$LANG non corretto nel file '$f_18'.\n" \
			"\tModificare il file $f_18 e riavviare il sistema." \

	fi

	if ! echo $LANG|grep -q 'it_IT.'
	then
		finito "ATTENZIONE:\n" \
			"\tValore in \$LANG non corretto nella shell corrente.\n" \
			"\tRiavviare il sistema."

	fi

	if test -f $f_pg && egrep '^(lc_messages|lc_monetary|lc_numeric|lc_time) *=' $f_pg | sed "/= *'it_IT.*'/!s/.*/x/" | grep -q '^x$'
	then
		finito "ATTENZIONE:\n" \
			"\tValore 'lc_*' non corretto nel file '$f_pg'.\n" \
			"\tOccorre disinstallare postgresql e rimuovere\n" \
			"\tla cartella /var/lib/pgsql/ prima di procedere."
	fi

	if ! echo "$LANG"|grep -E -q '.(UTF-8|utf8)$'
	then
		finito "ATTENZIONE: Impostazioni LANG errate.\n" \
			"\tLa variabile [LANG=$LANG] non contiene il valore UTF-8.\n" \
			"\tContattare l'assistenza tecnica."
	fi

	# Verifico se per caso esiste la cartella wkicosimi
	if [ -e "$BPOINT_ROOT/../wkicosimi" ]
	then
		finito "ATTENZIONE:\n" \
			"\tPrima di proseguire occorre rimuovere\n" \
			"\tla cartella '$(dirname $BPOINT_ROOT)/wkicosimi'"
	fi
fi

Traccia "Inizio operazioni di $ins_agg. Versione setup $VERSIONE ($VER_DATE)."
Traccia --sub "$sisdesc."

Traccia "Contratto di Licenza accettato e disponibile in:"
Traccia --sub "$BPOINT_PRG/etc/$EULA_nomefile"

#===============================================================================
# Verifico iscrizione tra le chiavi disattivate

if [ "$ins_agg" = "aggiornamento" ]
then
	if [ -z "$verifica_licenza" -o "$verifica_licenza" = 'no' ]
	then
		Traccia "Validita' Numero di Licenza non verificato."
	else
		Traccia "Verifica validita' Numero di Licenza"

		kb_rel="`catnoc $BPOINT_PRG/$file_versione| awk -F. '{printf(\"%02d%02d\", $1, $2)}'`"
		kb_chi="$BPOINT_PRG/etc/chiave"
		if [ ! -f $kb_chi ]
		then
			kb_chi="$BPOINT_PRG/etc/chiapag"
		fi
		if [ ! -f $kb_chi ]
		then
			st=5
		else
			keyblocc "$kb_rel" \
				 "$kb_chi" \
				 "`pwd`/db/keyblocc.dat" \
				 "`pwd`/db/bypass.dat"
			st=$?
		fi
		test -f /tmp/notest.key && st=0 

		case $st in
		(0) msg='Traccia --sub "Numero di licenza Valido. Proseguo."' ;;
		(1) msg='finito "\nProcedura di verifica numero di licenza danneggiata"' ;;
		(2) msg='finito "\nNumero di licenza disattivato"' ;;
		(3) msg='finito "\nErrore parametri procedura di verifica numero di licenza"' ;;
		(4) msg='Traccia --sub "Chiave con Bypass attivo. Proseguo."' ;;
		(5) msg='finito "\nFile prg/etc/chiave non accessibile o inesistente."' ;;
		(*) msg='finito "\nErrore generico procedura di verifica numero di licenza"' ;;
		esac

		eval $msg
	fi
fi

#===============================================================================
# Memorizzo in un file ($logdir/install.log) cosa sto per fare.

spooldir=/usr/spool
test -d $spooldir || ln -s /var/spool /usr/spool
logdir=$spooldir/sispac
test -d $logdir || mkdir $logdir
chmod 777 $logdir

(
cat << END
====================================
	Data operazioni	`date`
	Sistema		$sisdesc
	Versione    	$edz_version
	Tipo release	$edz_tipo
	Tipo operazione	$ins_agg
	Device		$device
	Sispac prg	$BPOINT_ROOT

END
) >> $logdir/install.log

#===============================================================================
# controllo componenti di sistema necessari
if [ "$ins_agg" = "installazione" ]
then
	# Installazione coponenti
	Traccia "Verifica presenza componenti necessari ..."

	complst=$(eval setup-bp-component.sh "--prod=$cod_prodotto" --test $opt_pg_std)
	st=$?

	if [ "$st" = '1' ]
	then
		Traccia --sub "Installazione componenti ($complst) ..."
		eval setup-bp-component.sh "--prod=$cod_prodotto" --installa $opt_pg_std 2>&1 |
			write_masterlog --only-log

		# Controllo che sia OK
		complst=$(eval setup-bp-component.sh "--prod=$cod_prodotto" --test $opt_pg_std)
		st=$?
	fi

	case $st in
	(0) Traccia --sub "Componenti necessari installati." ;;
	(1) Traccia --sub "Installazione componenti non riuscita." ;;
	(2) Traccia --sub "Installazione automatica non utilizzabile su questo sistema." ;;
	(*) finito "Errore $st: $complst" ;;
	esac

	if [ "$st" != '0' ]
	then
		Traccia --sub "Installare i seguenti componenti prima di procedere:"
		Traccia --sub "---[ $complst]."
		Traccia --sub "Procedura interrotta"
		finito "Componenti di sistema mancanti"
	fi

fi


#===============================================================================
# BPDS: in installazione preparo il DB
if [ "$cod_prodotto" = 'bpds' -a "$ins_agg" = "installazione" ]
then
	# Configurazione database
	Traccia "Verifica configurazione database ..."
	setup-bp-dbpsql.sh "--prod=$cod_prodotto" --test
	st=$?
	if [ "$st" = '1' ]
	then
		Traccia --sub "Configurazione database Postgress  ..."
		setup-bp-dbpsql.sh "--prod=$cod_prodotto" --configura 2>&1 |
			write_masterlog --only-log

		# Controllo che sia OK
		complst=$(setup-bp-dbpsql.sh "--prod=$cod_prodotto" --test)
		st=$?
	fi

	case $st in
	(0) Traccia --sub "Database Postgress Configurato." ;;
	(1) finito "Errore: Configurazione non riuscita." ;;
	(*) finito "Errore: Componenti di sistema non installati." ;;
	esac

fi

test -n "$STOP_DEBUG" && finito "STOP PER DEBUG: $STOP_DEBUG"

#===============================================================================
# Creazione cartella in cui installare
mkdir -p "$BPOINT_PRG"

#===============================================================================
# Creazione file di test per non concedere di operare in sispac fino a quando non o finito.
aincorso=$BPOINT_PRG/aincorso.tst
rm -f $aincorso
date > $aincorso

#===============================================================================
# Verifico quale elenco servizi devo utilizzare...
if [ "$ins_agg" = "installazione" ]
then
	# In fase di installazione i servizi da stoppare e startare sono quelli da installare
	wki_srv_stop_start="$all_inst_wki_srv"
else
	# In fase di aggiornamento i servizi da stoppare e startare sono quelli specificati nel descri
	wki_srv_stop_start="$all_rest_wki_srv"
fi

#===============================================================================
# Stop eventuale servizi ....
if [ -n "$wki_srv_stop_start" ]
then
	Traccia "Arresto Servizi WKI ..."
	# Interruzione servizio di autenticazione
	for servizio in $wki_srv_stop_start
	do
		# Verifico se il servizio c'e' ed è acceso
		if chkconfig --list $servizio 2>/dev/null| grep -q :on
		then
			Traccia --sub "Arresto $servizio"
			(
			exec 2>&1
			for act in stop
			do
				/etc/init.d/$servizio $act
				sleep 1
			done
			) | write_masterlog --only-log
		fi
	done
fi

#===============================================================================
# Gestione dei login wki
if [ -z "$subpkg_dir" ]
then
	if [ "$ins_agg" = "installazione" -o "$aggio_mklogin" = "SI" ]
	then
		Traccia "Creazione utenti."
		test ! -d $BPOINT_PRG &&
			mkdir $BPOINT_PRG
		for usr_grp in $all_sys_users
		do
			Traccia --sub "Creazione Utente $usr_grp ..."
			# NOTA: L'utente è anche utilizzato come gruppo
			(
			exec 2>&1
			set -x
			creasislog "$BPOINT_ROOT" "$usr_grp" "$usr_grp"
			) | write_masterlog --only-log
		done
	fi
fi

#===============================================================================
# Esecuzione rimozione file Obsoleti

if [ "$ins_agg" = "aggiornamento" -a -z "$subpkg_dir" ]
then
	#TODO: gestione file obsoleti per pacchetto o chiave in ini. Per ora disabilitato per sub-pkg

	file_obso='./obsoleti.lnx'
	Traccia "Rimozione files obsoleti ($(catnoc $file_obso|wc -l)) ..."
	sh cmd/rm-obsoleti.sh "$setupdir/$file_obso" "$BPOINT_ROOT"
fi

#===============================================================================
# Preparo elenco pacchi da utilizzre

if [ "$ins_agg" = "installazione" ]
then
	# Se sono in installazione scarico anche i pacchi per installazione
	key_pkg_lista='pkg_lista_ins'
else
	# In aggiornamento solo i pacchi base.
	key_pkg_lista='pkg_lista_agg'
fi

# Pacchi aggiunti da esterno (prima)
pkg_lista="$pkg_extrazip_prima"

# Ricavo la lista dei pacchi...
pkg_lista="$pkg_lista $(readfileini.sh --value-no-quote "$descrini" "$cod_prodotto.$key_pkg_lista")"

# Aggiungo eventuali fix specifiche
pkg_lista="$pkg_lista $(readfileini.sh --value-no-quote "$descrini" "$cod_prodotto.pkg_lista_fix")"
 
# Pacchi aggiunti da esterno (dopo)
pkg_lista="$pkg_lista $pkg_extrazip_dopo"

#===============================================================================
# Verifica dati contenuti nei supporti

Traccia "Verifica Supporti ($pkg_lista)"

# verifico gli zip da utilizzare e se OK ritorno il path del file
pathziplist=""
for nomepaccozip in $pkg_lista
do
	Traccia --sub "verifico $nomepaccozip ..."

	# Ricavo il path assoluto del file. La procedura eventualmente lo estrae dal pacco
	pathpaccozip="$(zipcheck_getpath "$supporto" "$nomepaccozip")"

	# Verifico se il file esiste
	if [ ! -f "$pathpaccozip" ]
	then
		finito "Errore: multi_unzip: file $nomepaccozip non trovato $supporto."
	else
		# Verifico l'integrita del pacco estaendo _lettura.ok
		rm -f "$MYTEMPDIR/_lettura.ok"
		if [ ! -f "$MYTEMPDIR/_lettura.ok" ]
		then
			# Se sono riuscito a rimuovere il file di test, allora tento di estrarlo
			eval "unzip -o -q -d '$MYTEMPDIR' '$pathpaccozip' _lettura.ok </dev/null"
		fi

		if [ ! -f "$MYTEMPDIR/_lettura.ok" ]
		then
			# se il file di test non esiste vuol dire che il file zip è rovinato.
			finito "Errore: multi_unzip: file $nomepaccozip danneggiato o privo di '_lettura.ok' in $supporto."
		fi
	fi

	# Separo con '*'
	pathziplist="$pathziplist$pathpaccozip*"
done

#===============================================================================
# Estrazione dati ...
Traccia "Estrazione Dati dai Supporti ($pkg_lista)"
unzip_log="$MYTEMPDIR/unzip.log"
date > "$unzip_log"

_ifs=$IFS
export IFS='*'
st=0
for pathpaccozip in $pathziplist
do
	Traccia --sub "estrazione dati da $(basename "$pathpaccozip") ..."

	eval "unzip -o -q -d '$BPOINT_ROOT' '$pathpaccozip' </dev/null >> '$unzip_log' 2>&1"
	st=$[st + $?]
	test $st != 0 && break
done
export IFS=$_ifs

if [ "$st" != 0 ]
then
	Traccia "Estrazione moduli da supporto terminata."
	tput bel
	Traccia ""
	Traccia "ATTENZIONE !!!"
	Traccia "Si sono verificati i seguenti errori durante la fase di estrapolazione dei files."
	Traccia	"-----------------------------"
	sed 's/^/\t| /' "$unzip_log" | write_masterlog
	Traccia	"-----------------------------"
	Traccia "Status $st"
	Traccia	"Contattare il supporto Tecnico."

	finito "Errore: Termine anomalo procedura."
fi
#read -p pause

#===============================================================================
# Eseguo eventuale comando shell inclusi in questa release PRIMA di procedere
if [ -n "$run_primasetup" ]
then
	Traccia "Eseguo operazioni iniziali ($run_primasetup)"
	run_subsetupcmd "$run_primasetup '--prima' -a '$ins_agg' -d '$BPOINT_ROOT' '$supporto'"
fi

# Operazioni di chiusura aggiornamento
if [ "$ins_agg" = "aggiornamento" ]
then
	# Aggiorno il file di log che indica l'aggiornamento avvenuto
	plog=$BPOINT_PRG/etc/aggiorna.log 
	sver=$BPOINT_PRG/$file_versione
	aver=$BPOINT_PRG/etc/ambver
	rele=`catnoc $sver|sed 1q`
	ambverData=`cat $aver 2>/dev/null| awk '{ print $2 }'` 
	ambverOra=`cat $aver 2>/dev/null| awk '{ print $3 }'` 
	data=`date +"%d/%m/%y"`

	echo "Versione $rele del $ambverData - $ambverOra in data $data">>$plog
fi

#===============================================================================
# Se non esistono genero una nuova chiave di attivazione
for chi in chiave chiapag
do
	if [ ! -f "$BPOINT_PRG/etc/$chi" ]
	then
		echo 'X00000' > "$BPOINT_PRG/etc/$chi"
	fi
done

if [ -z "$subpkg_dir" ]
then
	#===============================================================================
	# Se non sto gestendo un subpkg
	# Predispongo il comando shell da eseguire se si lavora come utente normale
	# Predispongo il file ".login" nuovo
	Traccia "Configurazione avvio procedura ..."
	(
		exec 2>&1
		cd $BPOINT_PRG
		rm -f sispac.sh
		ln -s cmd/unix/sispac.sh sispac.sh

		test -f .profile && mv .profile old.profile
		cp cmd/unix/P.profile .profile
		chmod 666    .profile
		chown "$system_user:" .profile

		pprofile=.bash_profile
		if [ -f $pprofile ]
		then
			cp .profile $pprofile
			chown "$system_user:" $pprofile
			chmod 666  $pprofile
		fi

	) | write_masterlog --only-log

	#===============================================================================
	# Attivo la gestione di hostetty per i pty
	if [ "$ins_agg" = "installazione" -a ! -f "$BPOINT_PRG/etc/hostetty.cfg" ]
	then
		# Attivo il meccanismo di aggiornamento formlink
		Traccia "Attivazione riconoscimento Posto di Lavoro statico..."
		(
			exec 2>&1
			PATH="$BPOINT_PRG/cmd/unix:$BPOINT_PRG/bin/linux:$PATH"
			export PATH
			SISPAC=$BPOINT_ROOT
			export SISPAC
			hostetty --config=WHO

			chmod 666 /dev/fd0 /dev/st0
		) | write_masterlog --only-log
	fi

	#===============================================================================
	# Operazioni di chiusura aggiornamento
	if [ "$ins_agg" = "aggiornamento" ] 
	then
		# Attivo il meccanismo di aggiornamento formlink
		Traccia "Impostazione aggiornamento formati ..."
		echo "Da sh install ..." > $BPOINT_PRG/etc/updatefo.cfg
		chmod 777 $BPOINT_PRG/etc $BPOINT_PRG/etc/updatefo.cfg

	fi

	#=========================================================================
	# sk3enable
	if [ "$ins_agg" = "installazione" ] 
	then
		Traccia "Attivazione sistema lettura chiave USB ..."
		$BPOINT_PRG/cmd/unix/sk3enable.sh --force 2>&1 |
			write_masterlog --only-log

		# /var/spool/sispac
		sysSispac=/usr/spool/sispac
		Traccia "Controllo cartelle temporanee."
		(
		if [ ! -d /usr/spool ]
		then
			ln -s /var/spool /usr/spool
		fi
		if [ ! -d $sysSispac ]
		then
			rm -rf $sysSispac
			mkdir $sysSispac
		fi
		chmod 777 $sysSispac
		)| write_masterlog
	fi

	#===============================================================================
	# Libreria di compatibilita

	Traccia "Verifica libreria di compatibilita libstdc++ ..."
	$BPOINT_PRG/cmd/unix/check-libstd.sh --native-mode |
		write_masterlog --only-log

	#===============================================================================
	# Attivazione licenza cobol
	if [ -e "$BPOINT_PRG/bin/linux/rts.msg" ]
	then
		Traccia "Pulizia precedente gestione RunTime Cobol MF Net Express ..."

		# Vecchia gestione
		rm -f "$BPOINT_PRG/etc/srvxpr.cfd"
		rm -f "$BPOINT_PRG/etc/srvxpr.cfg"

		rm -rf "$BPOINT_PRG/bin/linux/cobol_suse"
		rm -rf "$BPOINT_PRG/bin/linux/cobol_redhat51"

		Traccia --sub "Aggiornamento RunTime Cobol MF ..."
		(
			exec 2>&1
			cd $BPOINT_PRG
			$BPOINT_PRG/cmd/unix/checkaggio
		) | write_masterlog --only-log

		Traccia --sub "Attivazione Licenza Cobol MF ..."
		(
			exec 2>&1
			cd $BPOINT_PRG
			$BPOINT_PRG/cmd/unix/licobol $BPOINT_ROOT
		) | write_masterlog --only-log
	fi

	#=========================================================================
	# Faccio partire makeconv e tutte le cosette necessarie a BPDS...
	if [ \( "$cod_prodotto" = 'bpds' -a "$ins_agg" = "installazione" \) -o "$cod_prodotto" = 'bpds-smart' ]
	then
		Traccia "Inizializzazione cartelle e file per B.Point DS ..."

		setup_wkicosimi "$BPOINT_ROOT"

		if [ "$cod_prodotto" = 'bpds' ]
		then
			# Per DS ho già l'utente postgres installato, posso farlo.
			db_dir="$WKI_ROOT/wkicosimi/bpoint/db"
			mkdir -p "$db_dir"
			chown postgres: "$db_dir"
		fi

		Traccia --sub "File e cartelle preparate."
	fi

	#=========================================================================
	# Faccio partire makeconv e tutte le cosette necessarie a BPDS...
	if [ -n "$esegui_makeconv" ]
	then
		Traccia "Allineamento struttura database."

		# Imposto il comando da eseguire
		_cmd="$BPOINT_PRG/cmd/unix/makeconv.sh --no-stopstart-srv '$WKI_ROOT'"
		# lo loggo
		echo "Eseguo [$_cmd]" | write_masterlog --only-log
		# lo eseguo
		eval "$_cmd" 2>&1 | Traccia --sub 

		# Verifica DB
		Traccia "Verifica funzionamento database ..."
		su -l postgres -c "psql -d cosmo -c 'select cosmonet.getversion();'" 2>&1 |
			Traccia --sub

		# Disabilitata la creazione della condivisione (2/3/2015)
		if [ "$ins_agg" = "installazione-NO-MORE-USE" ]
		then
			Traccia "Configurazione servizio di condivisione cartella [wki] (SAMBA)..."
			(
			fsmb="/etc/samba/smb.conf"
			if grep -q '^[wki]' $fsmb
			then
				echo "Condivisione [wki] gia' attiva."
			else
				test ! -f $ftmp.wki &&
					cp -a $fsmb $fsmb.wki
				(
				cat <<-EOF
				[wki]
					comment = Cartella condivisione B.Point
					path = $WKI_ROOT
					writeable = yes
					guest ok = yes
					force user = bpoint
					force group = bpoint
					force create mode = 0777
					force directory mode = 0777
				EOF
				) >> $fsmb
				for srv in smb nmb
				do
					test -x /etc/init.d/$srv && {
						/sbin/chkconfig $srv on
						/etc/init.d/$srv restart
					}
				done
				echo "Condivisione [wki] attivata."
			fi
			) 2>&1 |
			Traccia --sub 

		fi
	fi

fi

#===============================================================================
# Sistemo l'owner e il gruppo dei file
if [ -z "$subpkg_dir" ]
then
	loc_bproot=$BPOINT_ROOT
	loc_azioni="chown chmod special"
else
	loc_bproot="$BPOINT_ROOT/$subpkg_dir"
	loc_azioni="chown chmod"
fi

Traccia "Impostazione accessi cartelle & files in $loc_bproot"

for azione in $loc_azioni
do
	case "$azione" in
	(chown) Traccia --sub "Impostazione proprietario ($system_user)." ;;
	(chmod) Traccia --sub "Impostazione permessi (777)." ;;
	(special) Traccia --sub "Impostazione permessi speciali (clinklpt)." ;;
	esac

	(
	exec 2>&1
	set -x
	# Aggiunta opzione 'new' per gestire un baco di srvagg
	sh cmd/setup-chperm.sh "$loc_bproot" "$ins_agg" "$system_user" "$azione" 'new'
	echo Status=$?
	) | write_masterlog --only-log
done

#===============================================================================
# su BPDS-SMART Eseguo la copia componenti
if [ "$cod_prodotto" = 'bpds-smart' ]
then
	Traccia "Esecuzione copia componenti per BpointDS Smart..."

	# Inizializzo bpsp_dir
	# Viene passata se chiamato da setup-dssmart.sh
	test -d "$DSSMART_BPSP_DIR" &&
		bpsp_prg="$DSSMART_BPSP_DIR/prg" ||
		bpsp_prg= "$BPOINT_PRG"

	# Post install per DS Smart
	_cmd="$BPOINT_PRG/bin/mono32/mono.sh $bpsp_prg/com/dssmart/linux/bin/wki.dsserver.exe '$BPOINT_PRG'"

	# Loggo ed eseguo il comando...
	(
	echo "Valore di \$DSSMART_BPSP_DIR=[$DSSMART_BPSP_DIR]"
	echo "Valore di \$bpsp_prg=[$bpsp_prg]"
	echo "Eseguo [$_cmd]"

	eval "$_cmd" 2>&1
	echo "Status=$?"
	) | write_masterlog --only-log

#	# Eseguo makeconv ...
#	Traccia "Esecuzione procedura makeconv per BpointDS Smart..."
#
#	_cmd="$BPOINT_PRG/cmd/unix/makeconv.sh --no-stopstart-srv '$WKI_ROOT' copylocal"
#	# lo loggo
#	echo "Eseguo [$_cmd]" | write_masterlog --only-log
#	# lo eseguo
#	(
#	eval "$_cmd" 2>&1
#	echo "Status=$?"
#	) | Traccia --sub 
fi

#===============================================================================
# Installazione servizio di autenticazione del client grafico
#if [ "$ins_agg" = "installazione" -a -n "$all_inst_wki_srv" ]
#then
if [ -n "$all_inst_wki_srv" ]
then
	Traccia "Verifica Installazione Servizi WKI ..."
	for servizio in $all_inst_wki_srv
	do
		# Verifico se il servizio c'e' ed è acceso al boot
		if ! chkconfig --list $servizio 2>/dev/null| grep -q :on
		then
			# Se il servizio non c'e' o non è acceso al boot lo installo
			Traccia --sub "Installazione di $servizio"
			(
			exec 2>&1
			set -x
			for act in 'uninstall' 'install'
			do
				# Eccezione per sispacweb
				test "$servizio" = 'sispacweb' -a "$act" = 'install' &&
					act=install-batch
				$BPOINT_PRG/cmd/unix/$servizio $act </dev/null
				sleep 1
			done
			set +x
			) | write_masterlog --only-log
		fi
	done
fi

#===============================================================================
# Riavvio i servizi
if [ -n "$wki_srv_stop_start" ]
then
	Traccia "Riavvio Servizi WKI ..."
	# Interruzione servizio di autenticazione
	for servizio in $wki_srv_stop_start
	do
		# Verifico se il servizio c'e' ed è acceso
		if chkconfig --list $servizio 2>/dev/null| grep -q :on
		then
			Traccia --sub "Avvio $servizio"
			(
			exec 2>&1
			set -x
			for act in stop start
			do
				/etc/init.d/$servizio $act
				sleep 1
			done
			) | write_masterlog --only-log
		fi
	done
fi

#===============================================================================
# Preparazione file configur per autoconfigurazione
if [ "$ins_agg" = "installazione" -a -z "$subpkg_dir" ]
then
	Traccia "Preparazione files per autoconfigurazione."
	configur=$BPOINT_PRG/etc/configur
	rm -rf $configur
	(
	echo "$BPOINT_ROOT"
	echo "$BPOINT_ROOT"
	echo "$BPOINT_ROOT"
	echo "$BPOINT_ROOT"
	catnoc moduli/*/elemodu | sort -u | awk -v p=$BPOINT_ROOT '{print $1, p}'
	) > $configur
	chmod 666 $configur
fi

# su BPDS Eseguo un backup preventivo
if [ "$cod_prodotto" = 'bpds' -a "$ins_agg" = "installazione" ]
then
	Traccia "Esecuzione primo backup DATABASE di $sisdesc..."
	(
		exec 2>&1
		# Per evitare problemi di blocco provo questo approccio:
		service bpointsrv stop
		sleep 2
		service bpointsrv start
		sleep 3
		$BPOINT_PRG/cmd/unix/wkirun.sh backup
	) | write_masterlog --only-log

	(
		exec 2>&1
		ls -l $BPOINT_ROOT/dtb/pg/pgbackup.backup 
	) | Traccia --sub

fi

#===============================================================================
# Eseguo eventuali comandi shell inclusi in questa release DOPO aver installato (postinstall)
if [ -n "$run_doposetup" ]
then
	Traccia "Eseguo operazioni finali ($run_doposetup)"
	run_subsetupcmd "$run_doposetup '--dopo' -a '$ins_agg' -d '$BPOINT_ROOT' '$supporto'"
fi

#===============================================================================
# Operazioni di termine procedura (se passo di qui correttamente)

# Sblocco l'accesso a bpoint
rm -f $aincorso

# Prendo il tempo di quando parto....
data_end=$(date +%s)

Traccia "Chiusura file di log $(write_masterlog --get-filename) ..."
write_masterlog --only-log 'Termine Procedura'

# Calcolo i secondi
min_sec=$[$data_end-$data_start]

if [ $min_sec -lt 60 ]
then
	# se minore di 60 esprimo in secondi
	testo='second'
else
	# Altrimenti in minuti
	min_sec=$[$min_sec/60]
	testo='minut'
fi
# Se singolo ... esprimo in singolare
test $min_sec = 1 && testo="${testo}o" || testo="${testo}i"

Traccia "La procedura di $ins_agg e' terminata correttamente in $min_sec $testo."

finito

